def dockerImageRepo = 'project-a/nginx-web-app'
def dockerImageTag
def dockerImage
def dockerRegistry = '092686437909.dkr.ecr.us-east-1.amazonaws.com'

pipeline
{
	agent any
	stages
	{
	stage('Build the Docker Image')
        {
            steps {
		script {
	            dockerImageTag="$dockerRegistry"+"/"+"$dockerImageRepo"+":"+"$BUILD_NUMBER"
                    echo "${dockerImageTag}"
                    echo 'Starting the Image Building'
                    dockerImage = docker.build "${dockerImageTag}"
                    sh 'docker images'
                    echo "$dockerImage"
				}
			}
		}
	stage('Publish Docker Images to DockerHub')
		{
			steps
			{
				echo "Pushing Docker image to Registory"
				sh("eval \$(aws ecr get-login --no-include-email --region us-east-1 | sed 's|https://||')")
					script
				{
                        dockerImage.push() 
                        echo "+++++++++++++++++++++++++++++++++++++++++++"
                        echo "Pushed Docker Image is  : ${dockerImageTag}"
                        echo "+++++++++++++++++++++++++++++++++++++++++++"
                    }
                    sh '''
                        docker images -a | grep project-a/nginx-web-app | awk '{print $3}' | xargs docker rmi
                    '''
				}
			}
    stage("ldeploy") {
		steps {
			sh "aws sts get-caller-identity && aws eks update-kubeconfig --region us-east-1 --name project-a-role"
			sh """
            cat	<<EOF > webapp.yml
                apiVersion: v1
                kind: Pod
                metadata:
                    labels:
                        run: nginx-web-app
                    name: nginx-web-app
                spec:
                    containers:
                    - name: nginx-web-app
                      image: 092686437909.dkr.ecr.us-east-1.amazonaws.com/project-a/nginx-web-app:$BUILD_NUMBER
                      ports:
                      - containerPort: 80
                        protocol: TCP
				EOF
			""".stripIndent()
			sh """
			cat webapp.yml
			touch webapp.yml
			kubectl apply -f webapp.yml
			"""
			}
		}
		
	}
}

